% loadODEscript function reads the MATLAB file line by line and 
% recognizes parameters between keywords: % parameters and % end of parameters
% equations are enclosed by keywords: % equations and % end of equations 

%   comment lines therebetween are allowed
%   parameters are stored to a cell array and the set of equations to a second one
%   the values of the parameters are assigned to the equations
%   the variable names are stored in an additional cell array.

function model = loadODEscript(mfile)


fid = fopen(mfile);

%search for the parameters
begin_param = '\<%.*parameter';
end_ = '\<%.*end';
param_arr ={};

begin_eq = '\<%.*equation';
eq_arr = {};

tline = fgetl(fid);
while ischar(tline)
    if ~isempty(regexp(tline,begin_param,'match'))
        
        while ischar(tline)
            tline = fgetl(fid);
            if isempty(regexp(tline,end_,'match'))
                if ~isempty(tline) && ~strncmp(tline,'%',1)
                    param_arr{end + 1} = tline;
                else
                    continue
                end
            else break
            end
        end
        
    end
    
    if ~isempty(regexp(tline,begin_eq,'match'))
        
        while ischar(tline)
            tline = fgetl(fid);
            if isempty(regexp(tline,end_,'match'))
                if ~isempty(tline) && ~strncmp(tline,'%',1)
                    eq_arr{end + 1} = tline;
                else
                    continue
                end
            else break
            end
        end
        
    end
    
    tline = fgetl(fid);
end

fclose(fid);

num = numel(eq_arr);
vars = cell(size(eq_arr));
rhs = cell(size(eq_arr));



for i=1:numel(param_arr)
    eq_sign = strfind(param_arr{i}, '=');
   
    cons{i}=strtrim(param_arr{i}(1:eq_sign-1)); 
    val{i}=strtrim(param_arr{i}(eq_sign+1:end-1));
end


for i=1:num
    eq_sign = strfind(eq_arr{i}, '=');
   
    vars{i}=strtrim(eq_arr{i}(2:eq_sign-1));
    vars{i}=regexprep(vars{i}, '\(([\d.]+)\)', '$1' );
    rhs{i}=strtrim(eq_arr{i}(eq_sign+1:end));
    rhs{i} =regexprep( rhs{i}, '\(([\d.]+)\)', '$1' );
    for j=1:numel(param_arr)
        rhs{i}=strrep(rhs{i},cons{j},val{j});
    end
end

model.species = vars;  
model.rhs = rhs;


% celldisp(model.rhs)
% celldisp(model.species)
end