% ODE system of the minimal cascade model for the mitotic oscillator involving
% cyclin and cdc2 kinase: BioModels#3  model name "Goldbeter1991-Min Mit Oscil"


function dy = odecyc(t,y)

% parameters
K1 = .02;
K2 = .02;
K3 =.01;
K4 = .01;
Kc=.5;
Kd=.001;
kd=.046;
V2=2;
V4=.7;
vs=.06;
vd=.25;
VM1=4;
VM3=1;
% end of parameters

dy=zeros(3,1);

% equations
% cyclin
dy(1) = vs - vd*y(3)*(y(1))/(Kd + y(1))-kd*y(1);
% M-phase-promoting factor
dy(2) = (y(1)*VM1)/(Kc + y(1))*(1-y(2))/(K1+1-y(2))-(V2*y(2))/(K2+y(2));
% protease
dy(3) = y(2)*VM3*(1-y(3))/(K3+1-y(3))-V4*(y(3))/(K4+y(3));
% end of equations






